glibmm: Gio::DBus::MethodInvocation Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::DBus::MethodInvocation Class Reference
D-Bus API

An Object for handling remote calls. More...

`#include <giomm/dbusmethodinvocation.h>`

Inheritance diagram for Gio::DBus::MethodInvocation:
[legend]

## Public Member Functions
virtual | ~MethodInvocation ()
GDBusMethodInvocation* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusMethodInvocation* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusMethodInvocation* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_sender () const
| Gets the bus name that invoked the method. More...
Glib::ustring | get_object_path () const
| Gets the object path the method was invoked on. More...
Glib::ustring | get_interface_name () const
| Gets the name of the D-Bus interface the method was invoked on. More...
Glib::ustring | get_method_name () const
| Gets the name of the method that was invoked. More...
Glib::RefPtr< const MethodInfo > | get_method_info () const
| Gets information about the method call, if any. More...
Glib::RefPtr< Connection > | get_connection ()
| Gets the DBusConnection the method was invoked on. More...
Glib::RefPtr< const Connection > | get_connection () const
| Gets the DBusConnection the method was invoked on. More...
Glib::RefPtr< Message > | get_message ()
| Gets the DBusMessage for the method invocation. More...
Glib::RefPtr< const Message > | get_message () const
| Gets the DBusMessage for the method invocation. More...
Glib::VariantContainerBase | get_parameters () const
| Gets the parameters of the method invocation. More...
void | return_value (const Glib::VariantContainerBase& parameters)
| Finishes handling a D-Bus method call by returning parameters. More...
void | return_value (const Glib::VariantContainerBase& parameters, const Glib::RefPtr< UnixFDList >& fd_list)
| Like g_dbus_method_invocation_return_value() but also takes a UnixFDList. More...
void | return_error (const Glib::ustring& domain, int code, const Glib::ustring& message)
| Like g_dbus_method_invocation_return_error() but without printf()-style formatting. More...
void | return_error (const Glib::Error& error)
| Like g_dbus_method_invocation_return_error() but takes a Error instead of the error domain, error code and message. More...
void | return_dbus_error (const Glib::ustring& error_name, const Glib::ustring& error_message)
| Finishes handling a D-Bus method call by returning an error. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::DBus::MethodInvocation > | wrap (GDBusMethodInvocation* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()

## Detailed Description

An Object for handling remote calls.

Instances of the MethodInvocation class are used when handling D-Bus method calls. It provides a way to asynchronously return results and errors.

The normal way to obtain a MethodInvocation object is to receive it as an argument to the SlotMethodCall that was passed to Gio::DBus::Connection::register_object().

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::DBus::MethodInvocation::~MethodInvocation | ( |  | ) |
| virtual

## Member Function Documentation

Glib::RefPtr<Connection> Gio::DBus::MethodInvocation::get_connection | ( |  | ) |

Gets the DBusConnection the method was invoked on.

Since glibmm 2.26:

Returns
  A DBusConnection. Do not free, it is owned by invocation.

Glib::RefPtr<const Connection> Gio::DBus::MethodInvocation::get_connection | ( |  | ) | const

Gets the DBusConnection the method was invoked on.

Since glibmm 2.26:

Returns
  A DBusConnection. Do not free, it is owned by invocation.

Glib::ustring Gio::DBus::MethodInvocation::get_interface_name | ( |  | ) | const

Gets the name of the D-Bus interface the method was invoked on.

If this method call is a property Get, Set or GetAll call that has been redirected to the method call handler then "org.freedesktop.DBus.Properties" will be returned. See DBusInterfaceVTable for more information.

Since glibmm 2.26:

Returns
  A string. Do not free, it is owned by invocation.

Glib::RefPtr<Message> Gio::DBus::MethodInvocation::get_message | ( |  | ) |

Gets the DBusMessage for the method invocation.

This is useful if you need to use low-level protocol features, such as UNIX file descriptor passing, that cannot be properly expressed in the Variant API.

See <xref linkend="gdbus-server"> and <xref linkend="gdbus-unix-fd-client"> for an example of how to use this low-level API to send and receive UNIX file descriptors.

Since glibmm 2.26:

Returns
  DBusMessage. Do not free, it is owned by invocation.

Glib::RefPtr<const Message> Gio::DBus::MethodInvocation::get_message | ( |  | ) | const

Gets the DBusMessage for the method invocation.

This is useful if you need to use low-level protocol features, such as UNIX file descriptor passing, that cannot be properly expressed in the Variant API.

See <xref linkend="gdbus-server"> and <xref linkend="gdbus-unix-fd-client"> for an example of how to use this low-level API to send and receive UNIX file descriptors.

Since glibmm 2.26:

Returns
  DBusMessage. Do not free, it is owned by invocation.

Glib::RefPtr<const MethodInfo> Gio::DBus::MethodInvocation::get_method_info | ( |  | ) | const

Gets information about the method call, if any.

If this method invocation is a property Get, Set or GetAll call that has been redirected to the method call handler then `0` will be returned. See g_dbus_method_invocation_get_property_info() and DBusInterfaceVTable for more information.

Since glibmm 2.26:

Returns
  A DBusMethodInfo or `0`. Do not free, it is owned by invocation.

Glib::ustring Gio::DBus::MethodInvocation::get_method_name | ( |  | ) | const

Gets the name of the method that was invoked.

Since glibmm 2.26:

Returns
  A string. Do not free, it is owned by invocation.

Glib::ustring Gio::DBus::MethodInvocation::get_object_path | ( |  | ) | const

Gets the object path the method was invoked on.

Since glibmm 2.26:

Returns
  A string. Do not free, it is owned by invocation.

Glib::VariantContainerBase Gio::DBus::MethodInvocation::get_parameters | ( |  | ) | const

Gets the parameters of the method invocation.

If there are no input parameters then this will return a GVariant with 0 children rather than `0`.

Since glibmm 2.26:

Returns
  A Variant tuple. Do not unref this because it is owned by invocation.

Glib::ustring Gio::DBus::MethodInvocation::get_sender | ( |  | ) | const

Gets the bus name that invoked the method.

Since glibmm 2.26:

Returns
  A string. Do not free, it is owned by invocation.

static GType Gio::DBus::MethodInvocation::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GDBusMethodInvocation* Gio::DBus::MethodInvocation::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GDBusMethodInvocation* Gio::DBus::MethodInvocation::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GDBusMethodInvocation* Gio::DBus::MethodInvocation::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gio::DBus::MethodInvocation::return_dbus_error | ( | const Glib::ustring& | error_name,
|  | const Glib::ustring& | error_message
| ) |  |

Finishes handling a D-Bus method call by returning an error.

This method will free invocation, you cannot use it afterwards.

Since glibmm 2.26:

Parameters

  error_name | A valid D-Bus error name.
  error_message | A valid D-Bus error message.

void Gio::DBus::MethodInvocation::return_error | ( | const Glib::ustring& | domain,
|  | int | code,
|  | const Glib::ustring& | message
| ) |  |

Like g_dbus_method_invocation_return_error() but without printf()-style formatting.

This method will free invocation, you cannot use it afterwards.

Since glibmm 2.26:

Parameters

  domain | A Quark for the Error error domain.
  code | The error code.
  message | The error message.

void Gio::DBus::MethodInvocation::return_error | ( | const Glib::Error& | error | ) |

Like g_dbus_method_invocation_return_error() but takes a Error instead of the error domain, error code and message.

This method will free invocation, you cannot use it afterwards.

Since glibmm 2.26:

void Gio::DBus::MethodInvocation::return_value | ( | const Glib::VariantContainerBase& | parameters | ) |

Finishes handling a D-Bus method call by returning parameters.

If the parameters GVariant is floating, it is consumed.

It is an error if parameters is not of the right format.

This method will free invocation, you cannot use it afterwards.

Since glibmm 2.26:

Parameters

  parameters | A Variant tuple with out parameters for the method or `0` if not passing any parameters.

void Gio::DBus::MethodInvocation::return_value | ( | const Glib::VariantContainerBase& | parameters,
|  | const Glib::RefPtr< UnixFDList >& | fd_list
| ) |  |

Like g_dbus_method_invocation_return_value() but also takes a UnixFDList.

This method is only available on UNIX.

This method will free invocation, you cannot use it afterwards.

Since glibmm 2.30:

Parameters

  parameters | A Variant tuple with out parameters for the method or `0` if not passing any parameters.
  fd_list | A UnixFDList or `0`.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::MethodInvocation > wrap | ( | GDBusMethodInvocation * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.